/**
 * 
 */
package de.mcs.tools.sps.holtek;

import de.mcs.tools.sps.EmulatorInternals;

/**
 * @author w.klaas
 *
 */
public class HoltekEmulatorInternals implements EmulatorInternals {
  int address;
  int a, b, c, d;
  int page;
  long delay;

  @Override
  public void reset() {
    address = 0x00;
    a = 0;
    b = 0;
    c = 0;
    d = 0;
    page = 0;
  }

  @Override
  public int getAddress() {
    return address;
  }

  @Override
  public void incAddress(int i) {
    address += i;
  }

  @Override
  public void setDelay(long l) {
    delay = l;
  }

  @Override
  public long getDelay() {
    return delay;
  }

  @Override
  public void setRegister(String registerName, byte data) {
    if ("A".equals(registerName.toUpperCase())) {
      a = data;
    }
    if ("B".equals(registerName.toUpperCase())) {
      b = data;
    }
    if ("C".equals(registerName.toUpperCase())) {
      c = data;
    }
    if ("D".equals(registerName.toUpperCase())) {
      d = data;
    }
  }

  @Override
  public byte getRegister(String register) {
    if ("A".equals(register.toUpperCase())) {
      return (byte) a;
    }
    if ("B".equals(register.toUpperCase())) {
      return (byte) b;
    }
    if ("C".equals(register.toUpperCase())) {
      return (byte) c;
    }
    if ("D".equals(register.toUpperCase())) {
      return (byte) d;
    }
    return 0;
  }
}
